"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regeneratorRuntime2 = require("@babel/runtime/regenerator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertValidationErrors = convertValidationErrors;
exports.validateWithTypedValidators = validateWithTypedValidators;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _sequelizeValidateSubfields = require("sequelize-validate-subfields");

var _marked = /*#__PURE__*/_regeneratorRuntime2.mark(convertValidationErrors);

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function checkPath(path) {
  var _iterator = _createForOfIteratorHelper(path),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var elem = _step.value;

      if (typeof elem !== 'string' && (0, _typeof2["default"])(elem) !== 'symbol') {
        throw new Error("invalid error path element: ".concat((0, _typeof2["default"])(elem), ", ").concat(String(elem)));
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return path;
}

function convertValidationErrors(validation) {
  var options,
      _iterator2,
      _step2,
      _step2$value,
      path,
      message,
      type,
      _args = arguments;

  return _regenerator["default"].wrap(function convertValidationErrors$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
          _iterator2 = _createForOfIteratorHelper(validation.errors);
          _context.prev = 2;

          _iterator2.s();

        case 4:
          if ((_step2 = _iterator2.n()).done) {
            _context.next = 15;
            break;
          }

          _step2$value = (0, _slicedToArray2["default"])(_step2.value, 3), path = _step2$value[0], message = _step2$value[1], type = _step2$value[2];

          if (!(options.reduxFormStyle && type.acceptsSomeCompositeTypes)) {
            _context.next = 11;
            break;
          }

          _context.next = 9;
          return {
            path: [].concat((0, _toConsumableArray2["default"])(checkPath(path)), ['_error']),
            message: message
          };

        case 9:
          _context.next = 13;
          break;

        case 11:
          _context.next = 13;
          return {
            path: checkPath(path),
            message: message
          };

        case 13:
          _context.next = 4;
          break;

        case 15:
          _context.next = 20;
          break;

        case 17:
          _context.prev = 17;
          _context.t0 = _context["catch"](2);

          _iterator2.e(_context.t0);

        case 20:
          _context.prev = 20;

          _iterator2.f();

          return _context.finish(20);

        case 23:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, null, [[2, 17, 20, 23]]);
}

function validateWithTypedValidators(type) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return (0, _sequelizeValidateSubfields.validateSubfields)( /*#__PURE__*/_regenerator["default"].mark(function _callee(value) {
    var validation;
    return _regenerator["default"].wrap(function _callee$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            validation = typeof type === 'function' ? type(value) : type.validate(value);

            if (!validation) {
              _context2.next = 3;
              break;
            }

            return _context2.delegateYield(convertValidationErrors(validation, options), "t0", 3);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee);
  }));
}